package edfinal.pk.rmissl;

import javax.net.ssl.*;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.Serializable;
import java.net.Socket;
import java.rmi.server.RMIClientSocketFactory;
import java.security.KeyStore;

/**
 * Created by IntelliJ IDEA.
 * User: pkrepszt
 * Date: Nov 16, 2004
 * Time: 7:24:57 PM
 * To change this template use File | Settings | File Templates.
 */
public class RMISSLClientSocketFactory implements RMIClientSocketFactory, Serializable {

    /**
     * RMISSLClientSocketFactory
     *
     * @param IpAddress
     * @param port
     * @return SSLSocket
     * @throws IOException
     */
    public Socket createSocket(String IpAddress, int port)
            throws IOException {
        SSLSocketFactory ssf = null;
        try {
            ByteArrayInputStream clientKeyStoreInputStream =
                    new ByteArrayInputStream(ClientKeyStoreFile.getCKSbytes());
            ByteArrayInputStream clientTrustStoreInputStream =
                    new ByteArrayInputStream(ClientKeyStoreFile.getCTSbytes());

            char[] passphrase = "ewunia27".toCharArray();
            SSLContext ctx = SSLContext.getInstance("TLS");
            KeyStore ks = KeyStore.getInstance("JKS");
            ks.load(clientKeyStoreInputStream, passphrase);
            KeyStore ts = KeyStore.getInstance("JKS");
            ts.load(clientTrustStoreInputStream, null);
            KeyManagerFactory kmf = KeyManagerFactory.getInstance("SunX509");
            kmf.init(ks, passphrase);
            TrustManagerFactory tmf = TrustManagerFactory.getInstance("SunX509");
            tmf.init(ts);
            ctx.init(kmf.getKeyManagers(), tmf.getTrustManagers(), null);
            ssf = ctx.getSocketFactory();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println("RMISSLClientSocketFactory created socket on port " + port);
        return (SSLSocket) ssf.createSocket(IpAddress, port);
    }

}







